#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Apr 17 07:59:21 2019

@author: torjus
"""

#LNG Fleet Analysis


import pandas as pd
import seaborn as sns
import numpy as np
import matplotlib.pyplot as plt

createDf = 0

if createDf == 1:
    df_all = pd.read_excel("LNGC_GPV_Database.xlsx",sheet_name="LNGC_In_Service_On_Order")
    df_all2 = pd.read_excel("LNGC_GPV_Database.xlsx",sheet_name="LNGC_All")


newBuild = ['Keel Laid','Launched','On Order/Not Commenced','Under Construction']
InOperation = ['In Service/Commission','In Casualty Or Repairing']


#Scatter Gas Capacity Vs Year Built Vessels In Service 
ax1 = sns.lmplot(x ='Year',y='Gas Capacity',data=df_all,fit_reg=False,hue='Category',legend=False)
ax1.set_ylabels('Gas Capacity [m$^3$]')
plt.legend(ncol = 1,loc='best')



#Scatter Service Speed vs Year Built Vessels in service
ax2 = sns.lmplot(x ='Year',y='Service Speed',data=df_all[df_all['Service Speed']!=0],fit_reg = False,hue='Category',legend=False)
ax2.set_ylabels('Service Speed [knots]')
plt.legend(ncol = 1,loc='best')

#Violin Plot Gas Capacity categorised by Ship type Group 

#NB THE VIOLIN PLOT NEEDS TO BE RUNNED SEPARATLY
#ax3 = sns.violinplot(x='Age',y='Gas Capacity',data=df_all)
#ax3.set_ylabel('Gas Capacity [m$^3$]')



#ax3.set_position([box3.x0,box3.y1,box3.width*0.9,box3.height*0.7])
#ax3.legend(loc='lower center',ncol=5)




#Total Built Capacity and Total Number of Vessels
createDf2 = 1

if createDf2 == 1:
    df_totals = pd.read_excel("LNGC_GPV_Database.xlsx",sheet_name="Total_Gas_Cap_Vessels")



fig = plt.figure()
axx1=fig.add_subplot(111)
axx1.bar(x='Year',height='Total Gas Capacity',data=df_totals)
axx1.set_ylabel('Gas Capacity [million m$^3$]')
axx1.set_xlabel('Year')
axx1.legend(['Fleet Gas Capacity'],bbox_to_anchor=(0.22,1.0))
axx2=axx1.twinx()
axx2.plot(df_totals['Year'],df_totals['Total Vessels'],c='r')
axx2.set_ylabel('Number of Vessels')
axx2.legend(['Number of Vessels (rhs)'],bbox_to_anchor=(0.5,1.0))


